#!/bin/bash

########################################################
######################################################## 
##                                                    ##
##              Checks Status of APC                  ##
##  Version 0.1, Copytight (c) 2005 by Rodolfo Greco  ##
##                                                    ##
########################################################
########################################################

### License Information: Free

if [ ! "$#" == "1" ]; then
echo "Specificare il nome o l'IP dell'host (APC)"
fi

HOSTNAME=$1
TEMPWARNING=42
TEMPCRITICAL=45
BATTWARNING=80
BATTCRITICAL=95
INPUTOK=220
OUTPUTOK=0
CAPACITYOK=100
REPLACEBATTOK=1

STATUSBATT=$(snmpget -v1 -c public -m ALL $HOSTNAME .1.3.6.1.4.1.318.1.1.1.4.2.3.0 | awk '{print $4}')
STATUSTEMP=$(snmpget -v1 -c public -m ALL $HOSTNAME .1.3.6.1.4.1.318.1.1.1.2.2.2.0 | awk '{print $4}')
OUTPUT=$(snmpget -v1 -c public -m ALL $HOSTNAME .1.3.6.1.4.1.318.1.1.1.4.2.4.0 | awk '{print $4}')
INPUT=$(snmpget -v1 -c public -m ALL $HOSTNAME .1.3.6.1.4.1.318.1.1.1.3.2.1.0 | awk '{print $4}')
CAPACITY=$(snmpget -v1 -c public -m ALL $HOSTNAME .1.3.6.1.4.1.318.1.1.1.2.2.1.0 | awk '{print $4}')
REPLACEBATT=$(snmpget -v1 -c public -m ALL $HOSTNAME .1.3.6.1.4.1.318.1.1.1.2.2.4.0 | awk '{print $4}')

#check batterie %
if [ $STATUSBATT -ge $BATTCRITICAL ]; then
  ECHO1="CRITICAL: Livello batteria --> $STATUSBATT";
  EXIT=1;
elif [ $STATUSBATT -ge $BATTWARNING ]; then
  ECHO1="WARNING: Livello batteria --> $STATUSBATT";
  EXIT=1;
elif [ $STATUSBATT -lt $BATTWARNING ]; then 
  ECHO1="OK: Livello batteria --> $STATUSBATT";
  EXIT=0;
fi

#check temperatura 
if [ $STATUSTEMP -ge $TEMPCRITICAL ]; then
  ECHO2="CRITICAL: Livello temperatura --> $STATUSTEMP";
  EXIT=1;
elif [ $STATUSTEMP -ge $TEMPWARNING ]; then
  ECHO2="WARNING: Livello temperatura --> $STATUSTEMP";
  EXIT=1;
elif [ $STATUSTEMP -lt $TEMPWARNING ]; then 
  ECHO2="OK: Livello temperatura --> $STATUSTEMP";
  EXIT=0;
fi

#check capacit
if [ $CAPACITY -lt $CAPACITYOK ]; then
  ECHO3="CRITICAL: Capacita' batterie --> $CAPACITY";
  EXIT=1;
else 
  ECHO3="OK: Capacita' batterie --> $CAPACITY";
  EXIT=0;
fi

#check input voltage
if [ $INPUT -lt $INPUTOK ]; then
  ECHO4="CRITICAL: Voltaggio entrante --> $INPUT";
  EXIT=1;
else
  ECHO4="OK: Voltaggio entrante --> $INPUT";
  EXIT=0;
fi

#check output voltage
if [ $OUTPUT -gt $OUTPUTOK ]; then
  ECHO5="CRITICAL: Voltaggio uscente --> $OUTPUT";
  EXIT=1;
else
  ECHO5="OK: Voltaggio uscente --> $OUTPUT";
  EXIT=0;
fi

#check stato batterie
if [ $REPLACEBATT -eq $REPLACEBATTOK ]; then
  ECHO6="OK: Stato batterie ok";
  EXIT=0;
else
  ECHO6="CRITICAL: Batterie da sostituire";
  EXIT=1;
fi

#risposte per nagios
if [ ! "$ECHO1" == "OK: Livello batteria --> $STATUSBATT" ]; then
  echo $ECHO1
  exit 2
fi
if [ ! "$ECHO2" == "OK: Livello temperatura --> $STATUSTEMP" ]; then
  echo $ECHO2
  exit 2
fi
if [ ! "$ECHO3" == "OK: Capacita' batterie --> $CAPACITY" ]; then
  echo $ECHO3
  exit 2
fi
if [ ! "$ECHO4" == "OK: Voltaggio entrante --> $INPUT" ]; then
  echo $ECHO4
  exit 2
fi
if [ ! "$ECHO5" == "OK: Voltaggio uscente --> $OUTPUT" ]; then
  echo $ECHO5
  exit 2
fi
if [ ! "$ECHO6" == "OK: Stato batterie ok" ]; then
  echo $ECHO6
  exit 2
fi

echo "OK: Status APC" "|" $ECHO1 "|" $ECHO2 "|" $ECHO3 "|" $ECHO4 "|" $ECHO5 "|" $ECHO6

exit $EXIT

### End ###
